## Introduction

Thank you for very much for your interest in contributing to our project! As a public service company, we want to shape a product that better matches our user needs and desires. Ideas or direct contributions are therefore warmly welcome and will be considered with great care, provided they fulfill a few requirements listed in this document. Please read it first before you decide to contribute.

### Why guidelines?

Our development team is small, our ability to quickly evaluate a need or a code submission is therefore critical. Please follow the present contributing guidelines so that we can efficiently consider your proposal. You should also read or our [code of conduct](CODE_OF_CONDUCT.md), providing a few guidelines to keep interactions as respectful as possible.

### Contributions we are looking for

Any kind of contribution is welcome, as long as it improves the overall quality of our product, for example:

* Requests for new features or ideas.
* Bug reports or fixes.
* Documentation improvements.
* Translation improvements.

Contributions can either take the form of simple issues where you describe the problem you face or what you would like to see in our products. If you feel up to the challenge, you can even submit code in the form of pull requests which our team will review.

### Contributions we are not looking for

Requests which are too vague or not related to our product will not be taken into account. We also have no editorial influence, any issue related to the content available on our platform will simply be closed.

## Contributing

You can use issues to report bugs, submit ideas or request features. People with a programming background can also submit changes directly via pull requests. Creating issues or pull requests requires you to own or [open](https://github.com/join) a GitHub account.

If you are not sure about the likelihood of a change you propose to be accepted, please open an issue first. We can discuss it there, especially whether it is compatible with our product or not. This way you can avoid creating an entire pull request we will never be able to merge.

Templates are available when you want to contribute:

* [Issues](https://github.com/SRGSSR/srgmediaplayer-ios/issues/new): Please follow our issue template. You can omit information which does not make sense but, in general, the more details you can provide, the better. This ensures we can quickly reproduce the problem you are facing, increasing the likelihood we can fix it. 
* [Pull requests](https://github.com/SRGSSR/srgmediaplayer-ios/compare): Please follow our code conventions, test your code well, and write unit tests when this makes sense. We will review your work and, if successful, merge it back into the main development branch.

## Code conventions

We currently have no formal code conventions, but we try to keep our codebase consistent. In general, having a look at the code itself should be enough for you to discover how you should write your changes.

## Code review

Pull requests, once complete, can be submitted for review by our team. Depending on the complexity of the involved changes, a few iterations might be needed. Once a pull request has been approved, it will be rebased, merged back into the development trunk and delivered with the next release.